#!/negi/bin/ruby
#-*- coding: utf-8 -*-

require 'socket'
require 'fileutils'
require 'yaml'

class Location
  LOCATIOND_WORKDIR = '/var/lib/locationd'
  LOCATION_CSV = '/negi/share/location-data/location-data.csv'

  def initialize
    FileUtils.mkpath(LOCATIOND_WORKDIR)
  end
  
  def latlong2addr(lat, long)
    min_abs = 180
    near_addr = nil
    near_lat  = nil
    near_long = nil
    open(LOCATION_CSV).each_line{|l|
      addr, llat, llong = l.chomp.split(',')
      addr, llat, llong = addr.gsub('"', ''), llat.to_f, llong.to_f
      abs = (lat - llat).abs + (long - llong).abs
      if min_abs > abs
        min_abs = abs
        near_addr, near_lat, near_long = addr, llat, llong
      end
    }
    return { abs:       min_abs,
             address:   near_addr,
             latitude:  near_lat,
             longitude: near_long }
  end
end

class LocationServer < Location
  LOCATIOND_SOCKET   = File.join(LOCATIOND_WORKDIR, 'locationd.sock')

  def start
    File.unlink(LOCATIOND_SOCKET) if File.exist?(LOCATIOND_SOCKET)
    us = UNIXServer.new(LOCATIOND_SOCKET)
    loop {
      Thread.start(us.accept){|sock|
        lat, long = sock.gets.chomp.split(',')
        sock.write(YAML.dump(latlong2addr(lat.to_f, long.to_f)))
        sock.close
      }.abort_on_exception =true
    }
  end
end

LocationServer.new.start

#p latlong2addr(35.5982, 139.6108)
